import 'dart:async';
import 'dart:typed_data';
import 'dart:io';

var fromByte = new StreamTransformer<Uint8List, List<int>>.fromHandlers(
  handleData: (data, sink) {
    print("Hah!");
    sink.add(data);
  }
);

Future connect(InternetAddress clientAddress, int port) {
  return RawSocket.connect(clientAddress, port).then((RawSocket sock) {
    socket = sock;

    socket.listen(dataHandler, onError: errorHandler, onDone: doneHandler, cancelOnError: false);
  }).catchError((Object e) {
    print("Unable to connect: $e");

    return true;
  });
}

RawSocket socket;

void dataHandler(event) {
  var num = socket.available();
  if (num > 0) { 
    print("Got the data!");
    var data = socket.read(num);
    print(data);
  }
}

void errorHandler(error, StackTrace trace) {
  print(error);
}

void doneHandler() {
  socket.close();
}